﻿local id;

--shift+左键拖动
local function UnitFramesPlus_PartyShiftDrag()
	PartyMemberFrame1:SetScript("OnMouseDown", function(self, elapsed)
		if UnitFramesPlusDB["party"]["movable"] == 1 then
			if IsShiftKeyDown() and (not InCombatLockdown()) then
				PartyMemberFrame1:StartMoving();
				UnitFramesPlusDB["party"]["moving"] = 1;
			end
		end
	end)

	PartyMemberFrame1:SetScript("OnMouseUp", function(self, elapsed)
		if UnitFramesPlusDB["party"]["moving"] == 1 then
			PartyMemberFrame1:StopMovingOrSizing();
			UnitFramesPlusDB["party"]["moving"] = 0;
		end
	end)

	PartyMemberFrame1:SetClampedToScreen(1);
end

--队友等级和生命值百分比
for id = 1, 4, 1 do
	local PartyLevel = _G["PartyMemberFrame"..id]:CreateFontString("PartyMemberFrame"..id.."Level", "OVERLAY", "GameTooltipText");
	PartyLevel:ClearAllPoints();
	PartyLevel:SetPoint("TOPLEFT", "PartyMemberFrame"..id, "BOTTOMLEFT", -9, 12);
	PartyLevel:SetFont(GameFontNormal:GetFont(), 10, "OUTLINE");
	PartyLevel:SetTextColor(1, 0.82, 0);
	PartyLevel:SetJustifyH("LEFT");

	local PartyHPPct = _G["PartyMemberFrame"..id]:CreateFontString("PartyMemberFrame"..id.."HPPct", "OVERLAY", "GameTooltipText");
	PartyHPPct:ClearAllPoints();
	PartyHPPct:SetPoint("LEFT", _G["PartyMemberFrame"..id.."HealthBar"], "RIGHT", 4, 0);
	PartyHPPct:SetFont(GameFontNormal:GetFont(), 10, "OUTLINE");
	PartyHPPct:SetTextColor(1, 0.82, 0);
	PartyHPPct:SetJustifyH("LEFT");
end

hooksecurefunc("PartyMemberFrame_UpdateMember", function(self)
	--队友等级显示
	local level = "";
	if UnitFramesPlusDB["party"]["level"] == 1 then
		if UnitLevel(self.unit) and UnitLevel(self.unit) >= 1 then
			level = UnitLevel(self.unit);
		end
	end
	_G["PartyMemberFrame"..self:GetID().."Level"]:SetText(level);

	--队友名字染色
	local color;
	if UnitFramesPlusDB["party"]["colorname"] == 1 then
		color = RAID_CLASS_COLORS[select(2, UnitClass(self.unit))];
	end
	if not color then color = NORMAL_FONT_COLOR end
	self.name:SetTextColor(color.r, color.g, color.b);
end)

--在设置插件时即时更新显示
function UnitFramesPlus_PartyLevelDisplayUpdate()
	for id = 1, 4, 1 do
		if UnitExists("party"..id) then
			local level = "";
			if UnitFramesPlusDB["party"]["level"] == 1 then
				if UnitLevel(_G["PartyMemberFrame"..id].unit) and UnitLevel(_G["PartyMemberFrame"..id].unit) >= 1 then
					level = UnitLevel(_G["PartyMemberFrame"..id].unit);
				end
			end
			_G["PartyMemberFrame"..id.."Level"]:SetText(level);
		end
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_PartyColornameDisplayUpdate()
	for id = 1, 4, 1 do
		if UnitExists("party"..id) then
			local color;
			if UnitFramesPlusDB["party"]["colorname"] == 1 then
				color = RAID_CLASS_COLORS[select(2, UnitClass(_G["PartyMemberFrame"..id].unit))];
			end
			if not color then color = NORMAL_FONT_COLOR end
			_G["PartyMemberFrame"..id].name:SetTextColor(color.r, color.g, color.b);
		end
	end
end

--生命值百分比
hooksecurefunc("PartyMemberFrame_UpdateMemberHealth", function(self, elapsed)
	if UnitFramesPlusDB["party"]["hp"] == 1 then
		if UnitFramesPlusDB["party"]["hppct"] == 1 then
			_G["PartyMemberFrame"..self:GetID().."HPPct"]:SetText(math.floor(100*self.unitHPPercent).."%");
		else
			local MaxHP, CurHP;
			_, MaxHP = _G["PartyMemberFrame"..self:GetID().."HealthBar"]:GetMinMaxValues();
			CurHP = _G["PartyMemberFrame"..self:GetID().."HealthBar"]:GetValue();
			_G["PartyMemberFrame"..self:GetID().."HPPct"]:SetText(CurHP.."/"..MaxHP);
		end
	else
		_G["PartyMemberFrame"..self:GetID().."HPPct"]:SetText("");
	end
end)

--在设置插件时即时更新显示
function UnitFramesPlus_PartyHealthPctDisplayUpdate()
	for id = 1, 4, 1 do
		if UnitExists("party"..id) then
			local HPPct = "";
			if UnitFramesPlusDB["party"]["hp"] == 1 then
				local MaxHP, CurHP;
				_, MaxHP = _G["PartyMemberFrame"..id.."HealthBar"]:GetMinMaxValues();
				if MaxHP > 0 then
					CurHP = _G["PartyMemberFrame"..id.."HealthBar"]:GetValue();
					if UnitFramesPlusDB["party"]["hppct"] == 1 then
						HPPct = math.floor(100*CurHP/MaxHP).."%";
					else
						HPPct = CurHP.."/"..MaxHP;
					end
				end
			end
			_G["PartyMemberFrame"..id.."HPPct"]:SetText(HPPct);
		end
	end
end

--头像内战斗信息
for id = 1, 4, 1 do
	local PartyPortraitIndicator = CreateFrame("Frame", "PartyPortraitIndicator"..id, _G["PartyMemberFrame"..id]);
	_G["PartyPortraitIndicator"..id]:SetFrameStrata("MEDIUM");
	_G["PartyPortraitIndicator"..id].feedbackStartTime = GetTime();
	_G["PartyPortraitIndicator"..id]:CreateFontString("PartyHitIndicator"..id, "OVERLAY", "NumberFontNormalHuge");
	_G["PartyHitIndicator"..id]:SetPoint("CENTER", _G["PartyMemberFrame"..id.."Portrait"], "CENTER", 0, 0);
	CombatFeedback_Initialize(_G["PartyPortraitIndicator"..id], _G["PartyHitIndicator"..id], 20);
end

function UnitFramesPlus_PartyPortraitIndicator()
	if UnitFramesPlusDB["party"]["indicator"] == 1 then
		for id = 1, 4, 1 do
			_G["PartyPortraitIndicator"..id]:RegisterEvent("UNIT_COMBAT");
			_G["PartyPortraitIndicator"..id]:RegisterEvent("PARTY_MEMBERS_CHANGED");
			_G["PartyPortraitIndicator"..id]:RegisterEvent("PARTY_LEADER_CHANGED");
			_G["PartyPortraitIndicator"..id]:RegisterEvent("UNIT_CONNECTION");
			_G["PartyPortraitIndicator"..id]:SetScript("OnEvent", function(self, event, ...)
				local arg1, arg2, arg3, arg4, arg5 = ...;
				if event == "PARTY_MEMBERS_CHANGED" or event == "PARTY_LEADER_CHANGED" or (event == "UNIT_CONNECTION" and arg1 == "party"..id and arg2 == false) then
					_G["PartyHitIndicator"..id]:Hide();
					return;
				end

				if event == "UNIT_COMBAT" and arg1 == "party"..id then
					CombatFeedback_OnCombatEvent(self, arg2, arg3, arg4, arg5);
					return;
				end
			end)

			_G["PartyPortraitIndicator"..id]:SetScript("OnUpdate", function(self, elapsed)
				CombatFeedback_OnUpdate(self, elapsed);
			end)
		end
	else
		for id = 1, 4, 1 do
			_G["PartyHitIndicator"..id]:Hide();
			_G["PartyPortraitIndicator"..id]:UnregisterEvent("UNIT_COMBAT");
			_G["PartyPortraitIndicator"..id]:UnregisterEvent("PARTY_MEMBERS_CHANGED");
			_G["PartyPortraitIndicator"..id]:UnregisterEvent("PARTY_LEADER_CHANGED");
			_G["PartyPortraitIndicator"..id]:UnregisterEvent("UNIT_CONNECTION");
			_G["PartyPortraitIndicator"..id]:SetScript("OnUpdate", nil)
			_G["PartyPortraitIndicator"..id]:SetScript("OnEvent", nil)
		end
	end
end

--队友离线检测
for id = 1, 4, 1 do
	local PartyOfflineStatus = _G["PartyMemberFrame"..id]:CreateTexture("PartyOfflineStatus"..id, "OVERLAY", _G["PartyMemberFrame"..id]);
	_G["PartyOfflineStatus"..id]:SetTexture("Interface\\CharacterFrame\\Disconnect-Icon");
	_G["PartyOfflineStatus"..id]:SetWidth(64);
	_G["PartyOfflineStatus"..id]:SetHeight(64);
	_G["PartyOfflineStatus"..id]:ClearAllPoints();
	_G["PartyOfflineStatus"..id]:SetPoint("LEFT", _G["PartyMemberFrame"..id], "LEFT", -7, -1);
	_G["PartyOfflineStatus"..id]:SetAlpha(0);
end

local pm = CreateFrame("Frame");
function UnitFramesPlus_PartyOfflineDetection()
	if UnitFramesPlusDB["party"]["onoff"] == 1 then
		pm:RegisterEvent("PLAYER_ENTERING_WORLD");
		pm:RegisterEvent("PARTY_MEMBERS_CHANGED");
		pm:RegisterEvent("PARTY_LEADER_CHANGED");
		pm:RegisterEvent("UNIT_CONNECTION");
		pm:SetScript("OnEvent", function(self, event, ...)
			if event == "PLAYER_ENTERING_WORLD" or event == "PARTY_MEMBERS_CHANGED" or event == "PARTY_LEADER_CHANGED" then
				UnitFramesPlus_PartyOfflineDetectionDisplayUpdate();
			elseif event == "UNIT_CONNECTION" then
				local unit, hasConnected = ...;
				for id = 1, 4, 1 do
					if UnitExists("party"..id) and unit == "party"..id then
						if hasConnected == false then
							_G["PartyMemberFrame"..id]:SetAlpha(0.5);
							_G["PartyOfflineStatus"..id]:SetAlpha(1);
						else
							_G["PartyMemberFrame"..id]:SetAlpha(1);
							_G["PartyOfflineStatus"..id]:SetAlpha(0);
						end
					end
				end
			end
		end)
	else
		for id = 1, 4, 1 do
			_G["PartyMemberFrame"..id]:SetAlpha(1);
			_G["PartyOfflineStatus"..id]:SetAlpha(0);
		end
		pm:UnregisterEvent("PLAYER_ENTERING_WORLD");
		pm:UnregisterEvent("PARTY_MEMBERS_CHANGED");
		pm:UnregisterEvent("PARTY_LEADER_CHANGED");
		pm:UnregisterEvent("UNIT_CONNECTION");
		pm:SetScript("OnEvent", nil)
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_PartyOfflineDetectionDisplayUpdate()
	for id = 1, 4, 1 do
		if UnitExists("party"..id) and UnitFramesPlusDB["party"]["onoff"] == 1 then
			if not UnitIsConnected("party"..id) then
				_G["PartyMemberFrame"..id]:SetAlpha(0.5);
				_G["PartyOfflineStatus"..id]:SetAlpha(1);
			else
				_G["PartyMemberFrame"..id]:SetAlpha(1);
				_G["PartyOfflineStatus"..id]:SetAlpha(0);
			end
		else
			_G["PartyMemberFrame"..id]:SetAlpha(1);
			_G["PartyOfflineStatus"..id]:SetAlpha(0);
		end
	end
end

--队友 Buff
local UFP_MAX_PARTY_BUFFS = 12;
for id = 1, 4, 1 do
	for j = 1, UFP_MAX_PARTY_BUFFS, 1 do
		local buff = CreateFrame("Button", "PartyMemberFrame"..id.."Buff"..j, _G["PartyMemberFrame"..id], "PartyBuffFrameTemplate");
		buff:SetID(j);
		buff:ClearAllPoints();
		if j == 1 then
			buff:SetPoint("TOPLEFT", _G["PartyMemberFrame"..id], "TOPLEFT", 48, -32);
		else
			buff:SetPoint("LEFT", _G["PartyMemberFrame"..id.."Buff"..j-1], "RIGHT", 2, 0);
		end
		buff:Hide();
	end
end

--Hide BuffTooltip
UFP_PartyMemberBuffTooltip_Update = PartyMemberBuffTooltip_Update;
PartyMemberBuffTooltip_Update = function(self)
	if UnitFramesPlusDB["party"]["buff"] ~= 1 then
		UFP_PartyMemberBuffTooltip_Update(self)
	end
	return;
end

hooksecurefunc("RefreshDebuffs", function(frame, unit, numDebuffs, suffix, checkCVar)
    if UnitFramesPlusDB["party"]["buff"] == 1 then
		local name = frame:GetName();
		if string.find(name, "^PartyMemberFrame%d$") then
			RefreshBuffs(frame, unit, UFP_MAX_PARTY_BUFFS);
		end
    end
end)

function UnitFramesPlus_PartyBuff()
    if UnitFramesPlusDB["party"]["buff"] == 1 then
		for id = 2, 4, 1 do
			local lowid = id - 1;
			_G["PartyMemberFrame"..id]:ClearAllPoints();
			_G["PartyMemberFrame"..id]:SetPoint("TOPLEFT", _G["PartyMemberFrame"..lowid.."PetFrame"], "BOTTOMLEFT", -23, -18);
		end

		for id = 1, 4, 1 do
			for j = 1, UFP_MAX_PARTY_BUFFS, 1 do
				_G["PartyMemberFrame"..id.."Buff"..j]:Show();
			end
			_G["PartyMemberFrame"..id.."Debuff1"]:ClearAllPoints();
			_G["PartyMemberFrame"..id.."Debuff1"]:SetPoint("BOTTOMLEFT", _G["PartyMemberFrame"..id], "TOPRIGHT", -8, 4);
			_G["PartyMemberFrame"..id.."PetFrame".."Debuff1"]:ClearAllPoints();
			_G["PartyMemberFrame"..id.."PetFrame".."Debuff1"]:SetPoint("LEFT", _G["PartyMemberFrame"..id.."PetFrame"], "RIGHT", -3, -1);
		end
	else
		for id = 2, 4, 1 do
			local lowid = id - 1;
			_G["PartyMemberFrame"..id]:ClearAllPoints();
			_G["PartyMemberFrame"..id]:SetPoint("TOPLEFT", _G["PartyMemberFrame"..lowid.."PetFrame"], "BOTTOMLEFT", -23, -10);
		end

		for id = 1, 4, 1 do
			for j = 1, UFP_MAX_PARTY_BUFFS, 1 do
				_G["PartyMemberFrame"..id.."Buff"..j]:Hide();
			end
			_G["PartyMemberFrame"..id.."Debuff1"]:ClearAllPoints();
			_G["PartyMemberFrame"..id.."Debuff1"]:SetPoint("TOPLEFT", _G["PartyMemberFrame"..id], "TOPLEFT", 48, -32);
			_G["PartyMemberFrame"..id.."PetFrame".."Debuff1"]:ClearAllPoints();
			_G["PartyMemberFrame"..id.."PetFrame".."Debuff1"]:SetPoint("TOPLEFT", _G["PartyMemberFrame"..id.."PetFrame"], "TOPLEFT", 24, -16);
		end
	end
end

function UnitFramesPlus_PartyInit()
	UnitFramesPlus_PartyShiftDrag();
	UnitFramesPlus_PartyOfflineDetection();
	UnitFramesPlus_PartyPortraitIndicator();
	UnitFramesPlus_PartyBuff();
end
