﻿--shift+左键拖动
local function UnitFramesPlus_PlayerShiftDrag()
	PlayerFrame:SetScript("OnMouseDown", function(self, elapsed)
		if UnitFramesPlusDB["player"]["movable"] == 1 then
			if IsShiftKeyDown() and (not InCombatLockdown()) then
				PlayerFrame:StartMoving();
				UnitFramesPlusDB["player"]["moving"] = 1;
			end
		end
	end)

	PlayerFrame:SetScript("OnMouseUp", function(self, elapsed)
		if UnitFramesPlusDB["player"]["moving"] == 1 then
			PlayerFrame:StopMovingOrSizing();
			UnitFramesPlusDB["player"]["moving"] = 0;
		end
	end)

	PlayerFrame:SetClampedToScreen(1);
end

--精英头像
function UnitFramesPlus_PlayerDragon()
	if UnitFramesPlusDB["player"]["dragon"] == 1 then
		if UnitFramesPlusDB["player"]["raretype"] == 1 then
			PlayerTexture = "Interface\\TargetingFrame\\UI-TargetingFrame-Elite";
		elseif UnitFramesPlusDB["player"]["raretype"] == 2 then
			PlayerTexture = ("Interface\\TargetingFrame\\UI-TargetingFrame-Rare-Elite");
		elseif UnitFramesPlusDB["player"]["raretype"] == 3 then
			PlayerTexture = ("Interface\\TargetingFrame\\UI-TargetingFrame-Rare");
		end
	else
		PlayerTexture = ("Interface\\TargetingFrame\\UI-TargetingFrame");
	end
	PlayerFrameTexture:SetTexture(PlayerTexture);

	if UnitFramesPlusDB["player"]["extbar"] == 1 then
		PlayerExtBar:SetTexture(PlayerTexture);
	end
end

--额外显示的生命值、法力值框架
local PlayerExtHP = PlayerFrame:CreateFontString("PlayerExtHP", "OVERLAY", "TextStatusBarText");
PlayerExtHP:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
PlayerExtHP:SetTextColor(1, 0.75, 0);
PlayerExtHP:Hide();

local PlayerExtMP = PlayerFrame:CreateFontString("PlayerExtMP", "OVERLAY", "TextStatusBarText");
PlayerExtMP:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
PlayerExtMP:SetTextColor(1, 1, 1);
PlayerExtMP:Hide();

local PlayerExtHPPct = PlayerFrame:CreateFontString("PlayerExtHPPct", "OVERLAY", "TextStatusBarText");
PlayerExtHPPct:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
PlayerExtHPPct:SetTextColor(0, 1, 0);
PlayerExtHPPct:Hide();

--扩展框
local PlayerExtBar = PlayerFrame:CreateTexture("PlayerExtBar", "ARTWORK");
PlayerExtBar:Hide();

local PlayerExtBarBG = PlayerFrame:CreateTexture("PlayerExtBarBG", "BACKGROUND");
PlayerExtBarBG:Hide();

local fixforvehicle = CreateFrame("Frame");
function UnitFramesPlus_PlayerExtbar()
	PlayerExtBar:SetTexture(PlayerTexture);
	PlayerExtBar:SetWidth(138);
	PlayerExtBar:SetHeight(128);
	PlayerExtBar:SetTexCoord(0.3984375, 0, 0, 1);
	PlayerExtBar:ClearAllPoints();
	PlayerExtBar:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 226, 0);

	PlayerExtBarBG:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background");
	PlayerExtBarBG:SetWidth(96);
	PlayerExtBarBG:SetHeight(42);
	PlayerExtBarBG:SetVertexColor(0, 0, 0, 0.5);
	PlayerExtBarBG:ClearAllPoints();
	PlayerExtBarBG:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 226, -23);
	if UnitFramesPlusDB["player"]["extbar"] == 1 then
		PlayerExtBarBG:Show();
		PlayerExtBar:Show();
		PlayerExtHP:ClearAllPoints();
		PlayerExtHP:SetPoint("CENTER", PlayerFrameHealthBar, "RIGHT", 53, -1);
		PlayerExtHP:SetJustifyH("CENTER");
		PlayerExtHP:Show();
		PlayerExtMP:ClearAllPoints();
		PlayerExtMP:SetPoint("CENTER", PlayerFrameManaBar, "RIGHT", 53, -1);
		PlayerExtMP:SetJustifyH("CENTER");
		PlayerExtMP:Show();
		PlayerExtHPPct:ClearAllPoints();
		PlayerExtHPPct:SetPoint("CENTER", PlayerFrameHealthBar, "RIGHT", 55, 14);
		PlayerExtHPPct:SetJustifyH("CENTER");
		PlayerExtHPPct:Show();

		--上载具后隐藏扩展框
		fixforvehicle:RegisterEvent("UNIT_ENTERED_VEHICLE");
		fixforvehicle:RegisterEvent("UNIT_EXITED_VEHICLE");
		fixforvehicle:SetScript("OnEvent", function(self, event, ...)
			local unit = ...;
			if event == "UNIT_ENTERED_VEHICLE" then
				if unit == "player" and UnitHasVehicleUI("player") then
					PlayerExtBarBG:SetAlpha(0);
					PlayerExtBar:SetAlpha(0);
					PlayerExtHP:SetAlpha(0);
					PlayerExtMP:SetAlpha(0);
					PlayerExtHPPct:SetAlpha(0);
				end
			elseif event == "UNIT_EXITED_VEHICLE" then
				if unit == "player" then
					PlayerExtBarBG:SetAlpha(0.5);
					PlayerExtBar:SetAlpha(1);
					PlayerExtHP:SetAlpha(1);
					PlayerExtMP:SetAlpha(1);
					PlayerExtHPPct:SetAlpha(1);
				end
			end;
		end)

		UnitFramesPlus_PlayerHealth();
		UnitFramesPlus_PlayerHPValueDisplayUpdate();
		UnitFramesPlus_PlayerPower();
		UnitFramesPlus_PlayerMPValueDisplayUpdate();
	else
		PlayerExtBarBG:Hide();
		PlayerExtBar:Hide();
		fixforvehicle:UnregisterEvent("UNIT_ENTERED_VEHICLE");
		fixforvehicle:UnregisterEvent("UNIT_EXITED_VEHICLE");
		fixforvehicle:SetScript("OnEvent", nil)
		UnitFramesPlus_PlayerHPMPPct();
	end
end

--不显示扩展框时显示额外的生命值、法力值
function UnitFramesPlus_PlayerHPMPPct()
	if UnitFramesPlusDB["player"]["hpmp"] == 1 then
		PlayerExtHP:ClearAllPoints();
		PlayerExtHP:SetPoint("LEFT", PlayerFrameHealthBar, "RIGHT", 5, -1);
		PlayerExtHP:SetJustifyH("LEFT");
		PlayerExtHP:Show();
		PlayerExtMP:ClearAllPoints();
		PlayerExtMP:SetPoint("LEFT", PlayerFrameManaBar, "RIGHT", 5, -1);
		PlayerExtMP:SetJustifyH("LEFT");
		PlayerExtMP:Show();
		PlayerExtHPPct:ClearAllPoints();
		PlayerExtHPPct:SetPoint("LEFT", PlayerFrameHealthBar, "RIGHT", 5, 14);
		PlayerExtHPPct:SetJustifyH("LEFT");
		PlayerExtHPPct:Show();
	else
		PlayerExtHP:Hide();
		PlayerExtMP:Hide();
		PlayerExtHPPct:Hide();
	end
	UnitFramesPlus_PlayerHealth();
	UnitFramesPlus_PlayerHPValueDisplayUpdate();
	UnitFramesPlus_PlayerPower();
	UnitFramesPlus_PlayerMPValueDisplayUpdate();
end

--显示额外的生命值
local PlayerHealth = CreateFrame("Frame");
function UnitFramesPlus_PlayerHealth()
	if UnitFramesPlusDB["player"]["extbar"] == 0 and UnitFramesPlusDB["player"]["hpmp"] == 0 then
		PlayerHealth:UnregisterEvent("UNIT_HEALTH");
		PlayerHealth:SetScript("OnEvent", nil);
	else
		PlayerHealth:RegisterEvent("UNIT_HEALTH");
		PlayerHealth:SetScript("OnEvent", function(self, event, ...)
			local unit = ...;
			if event == "UNIT_HEALTH" and unit == "player" then
				UnitFramesPlus_PlayerHPValueDisplayUpdate();
			end
		end)
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_PlayerHPValueDisplayUpdate()
	local CurHP = UnitHealth("player");
	local MaxHP = UnitHealthMax("player");
	local CurHPfix, MaxHPfix = GetValueFix(CurHP, MaxHP, UnitFramesPlusDB["player"]["unit"]);
	local HPPct = "";

	if MaxHP > 0 then
		HPPct = math.floor(100*CurHP/MaxHP).."%";
	end

	if UnitFramesPlusDB["player"]["hpmptype"] == 2 then
		PlayerExtHP:SetText(HPPct);
		if UnitFramesPlusDB["player"]["coord"] ~= 1 then
			PlayerExtHPPct:SetText("");
		end
	elseif UnitFramesPlusDB["player"]["extbar"] == 1 or UnitFramesPlusDB["player"]["hpmptype"] == 1 then
		PlayerExtHP:SetText(CurHPfix.."/"..MaxHPfix);
		if UnitFramesPlusDB["player"]["coord"] ~= 1 then
			PlayerExtHPPct:SetText(HPPct);
		end
	end
end

--显示坐标
local coord = CreateFrame("Frame");
function UnitFramesPlus_PlayerCoordinate()
	if UnitFramesPlusDB["player"]["coord"] == 1 then
		coord:RegisterEvent("ZONE_CHANGED");
		coord:RegisterEvent("ZONE_CHANGED_INDOORS");
		coord:RegisterEvent("ZONE_CHANGED_NEW_AREA");
		coord:SetScript("OnEvent", function(self, event)
			SetMapToCurrentZone();
			local x, y = GetPlayerMapPosition("player");
			if x~=0 and y~=0 then
				PlayerExtHPPct:SetText(format("(%.0f, %.0f)", x*100, y*100));
			end
		end)

		coord:SetScript("OnUpdate", function(self, elapsed)
			self.timer = (self.timer or 0) + elapsed;
			if self.timer >= 0.3 then
				local x, y = GetPlayerMapPosition("player");
				if x~=0 and y~=0 then
					PlayerExtHPPct:SetText(format("(%.0f, %.0f)", x*100, y*100));
				end
				self.timer = 0;
			end
		end)
	else
		coord:UnregisterEvent("ZONE_CHANGED");
		coord:UnregisterEvent("ZONE_CHANGED_INDOORS");
		coord:UnregisterEvent("ZONE_CHANGED_NEW_AREA");
		coord:SetScript("OnEvent", nil);
		coord:SetScript("OnUpdate", nil);
	end
end

--显示额外的法力值
local PlayerPower = CreateFrame("Frame");
function UnitFramesPlus_PlayerPower()
	if UnitFramesPlusDB["player"]["extbar"] == 0 and UnitFramesPlusDB["player"]["hpmp"] == 0 then
		PlayerPower:UnregisterEvent("UNIT_POWER");
		PlayerPower:SetScript("OnEvent", nil);
	else
		PlayerPower:RegisterEvent("UNIT_POWER");
		PlayerPower:SetScript("OnEvent", function(self, event, ...)
			local unit = ...;
			if unit == "player" then
				UnitFramesPlus_PlayerMPValueDisplayUpdate();
			end
		end)
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_PlayerMPValueDisplayUpdate()
	local CurMP = UnitPower("player");
	local MaxMP = UnitPowerMax("player");
	local CurMPfix, MaxMPfix = GetValueFix(CurMP, MaxMP, UnitFramesPlusDB["player"]["unit"]);
	local MPPct = "";
	local powerType = UnitPowerType("player");

	if powerType == 0 then
		if MaxMP > 0 then
			MPPct = math.floor(100*CurMP/MaxMP).."%";
		end
	else
		MPPct = CurMP;
		if MPPct == 0 then MPPct = "" end
	end

	if UnitFramesPlusDB["player"]["hpmptype"] == 2 then
		PlayerExtMP:SetText(MPPct);
	elseif UnitFramesPlusDB["player"]["extbar"] == 1 or UnitFramesPlusDB["player"]["hpmptype"] == 1 then
		PlayerExtMP:SetText(CurMPfix.."/"..MaxMPfix);
	end
end

--生命条百分比染色
function UnitFramesPlus_PlayerColorHPBar()
	if UnitFramesPlusDB["player"]["colorhp"] == 1 then
		PlayerFrameHealthBar:SetScript("OnValueChanged", function(self, value)
			local _, MaxHP = self:GetMinMaxValues();
			local CurHP = self:GetValue();
			local Pct = math.floor(100*CurHP/MaxHP)/100;
			local r, g, b = 0, 1, 0;
			if Pct > 0.5 then
				r = (1.0-Pct)*2;
				g = 1.0;
			else
				r = 1.0;
				g = Pct*2;
			end
			if r < 0 then r = 0 end
			if g < 0 then g = 0 end
			if r > 1 then r = 1 end
			if g > 1 then g = 1 end
			PlayerFrameHealthBar:SetStatusBarColor(r, g, b);
		end)
	else
		PlayerFrameHealthBar:SetStatusBarColor(0, 1, 0);
		PlayerFrameHealthBar:SetScript("OnValueChanged", nil);
	end
end

--数值转换
function GetValueFix(valueCur, valueMax, valuetype)
	local valueCurfix, valueMaxfix, unitbig, unitsmall;
	if valuetype == 1 then
		unitbig = "m";
		unitsmall = "k";
		if valueCur > 10000000 then
			valueCurfix = math.floor(valueCur/1000000)..unitbig;
		elseif valueCur > 10000 then
			valueCurfix = math.floor(valueCur/1000)..unitsmall;
		else
			valueCurfix = valueCur;
		end

		if valueMax > 10000000 then
			valueMaxfix = math.floor(valueCur/1000000)..unitbig;
		elseif valueMax > 10000 then
			valueMaxfix = math.floor(valueMax/1000)..unitsmall;
		else
			valueMaxfix = valueMax;
		end
	else
		valueCurfix = valueCur;
		valueMaxfix = valueMax;
	end
	return valueCurfix, valueMaxfix;
end

--头像内战斗信息
function UnitFramesPlus_PlayerPortraitIndicator()
	local registered = PlayerFrame:IsEventRegistered("UNIT_COMBAT");
	local petregistered = PetFrame:IsEventRegistered("UNIT_COMBAT");
	if UnitFramesPlusDB["player"]["indicator"] == 1 then
		if not registered then
			PlayerFrame:RegisterEvent("UNIT_COMBAT");
		end
		if not petregistered then
			PetFrame:RegisterEvent("UNIT_COMBAT");
		end
	else
		if registered then
			PlayerFrame:UnregisterEvent("UNIT_COMBAT");
		end
		if petregistered then
			PetFrame:UnregisterEvent("UNIT_COMBAT");
		end
	end
end

--3D头像
local Player3DPortrait = CreateFrame("PlayerModel", "Player3DPortrait", PlayerFrame);
Player3DPortrait:SetWidth(51);
Player3DPortrait:SetHeight(51);
Player3DPortrait:SetFrameLevel(1);
Player3DPortrait:ClearAllPoints();
Player3DPortrait:SetPoint("CENTER", PlayerPortrait, "CENTER", 0, -1);
Player3DPortrait:Hide();
Player3DPortrait.BackLayer = Player3DPortrait:CreateTexture("Player3DPortraitBackLayer","BACKGROUND");
Player3DPortrait.BackLayer:SetTexture("Interface\\AddOns\\UnitFramesPlus\\Portrait3D");
Player3DPortrait.BackLayer:SetWidth(64);
Player3DPortrait.BackLayer:SetHeight(64);
Player3DPortrait.BackLayer:ClearAllPoints();
Player3DPortrait.BackLayer:SetPoint("CENTER", Player3DPortrait, "CENTER", 0, 0);
Player3DPortrait.BackLayer:Hide();

local p3d = CreateFrame("Frame");
function UnitFramesPlus_Player3DPortrait()
	if UnitFramesPlusDB["player"]["p3d"] == 1 then
		PlayerPortrait:Hide();
		Player3DPortrait:Show();
		UnitFramesPlus_Player3DPortraitBGDisplayUpdate();
		p3d:RegisterEvent("PLAYER_ENTERING_WORLD");
		p3d:RegisterEvent("UNIT_PORTRAIT_UPDATE");
		p3d:RegisterEvent("UNIT_MODEL_CHANGED");
		p3d:RegisterEvent("PLAYER_DEAD");
		p3d:RegisterEvent("PLAYER_ALIVE");
		p3d:RegisterEvent("PLAYER_UNGHOST");
		p3d:RegisterEvent("UNIT_ENTERED_VEHICLE");
		p3d:RegisterEvent("UNIT_EXITED_VEHICLE");
		p3d:SetScript("OnEvent", function(self, event, ...)
			local unit = ...;
			if event == "PLAYER_ENTERING_WORLD" then
				if UnitFramesPlusDB["player"]["p3dbg"] == 1 then
					local color = RAID_CLASS_COLORS[select(2, UnitClass("player"))] or NORMAL_FONT_COLOR;
					Player3DPortrait.BackLayer:SetVertexColor(color.r/1.5, color.g/1.5, color.b/1.5, 1);
				end
				UnitFramesPlus_Player3DPortraitDisplayUpdate();
			elseif (event == "UNIT_PORTRAIT_UPDATE" or event == "UNIT_MODEL_CHANGED" or event == "UNIT_EXITED_VEHICLE") and unit == "player" then
				UnitFramesPlus_Player3DPortraitDisplayUpdate();
			elseif event == "PLAYER_DEAD" then
				Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 0.3, 0.3);
			elseif event == "PLAYER_ALIVE" then
				if UnitIsGhost("player") then
					Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 0.25, 0.25, 0.25);
				else
					Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 1, 1);
				end
			elseif event == "PLAYER_UNGHOST" then
				Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 1, 1);
			elseif event == "UNIT_ENTERED_VEHICLE" and unit == "player" and UnitHasVehicleUI("player") then
				Player3DPortrait:SetPortraitZoom(1);
				Player3DPortrait:ClearModel();
				Player3DPortrait:SetUnit("vehicle");
			end
		end)
	else
		PlayerPortrait:Show();
		Player3DPortrait:Hide();
		p3d:UnregisterEvent("PLAYER_ENTERING_WORLD");
		p3d:UnregisterEvent("UNIT_PORTRAIT_UPDATE");
		p3d:UnregisterEvent("UNIT_MODEL_CHANGED");
		p3d:UnregisterEvent("PLAYER_DEAD");
		p3d:UnregisterEvent("PLAYER_ALIVE");
		p3d:UnregisterEvent("PLAYER_UNGHOST");
		p3d:UnregisterEvent("UNIT_ENTERED_VEHICLE");
		p3d:UnregisterEvent("UNIT_EXITED_VEHICLE");
		p3d:SetScript("OnEvent", nil);
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_Player3DPortraitDisplayUpdate()
	Player3DPortrait:SetPortraitZoom(1);
	Player3DPortrait:ClearModel();
	Player3DPortrait:SetUnit("player");
	if UnitIsGhost("player") then
		Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 0.25, 0.25, 0.25);
	elseif UnitIsDead("player") then
		Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 0.3, 0.3);
	else
		Player3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 1, 1);
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_Player3DPortraitBGDisplayUpdate()
	if UnitFramesPlusDB["player"]["p3d"] == 1 and UnitFramesPlusDB["player"]["p3dbg"] == 1 then
		Player3DPortrait.BackLayer:Show();
	else
		Player3DPortrait.BackLayer:Hide();
	end
end

function UnitFramesPlus_PlayerInit()
	UnitFramesPlus_PlayerShiftDrag();
	UnitFramesPlus_PlayerDragon();
	UnitFramesPlus_PlayerExtbar();
	UnitFramesPlus_PlayerColorHPBar();
	UnitFramesPlus_PlayerPortraitIndicator();
	UnitFramesPlus_Player3DPortrait();
	UnitFramesPlus_PlayerCoordinate();
end
