﻿UnitFramesPlusDefaultDB = {
	player = {
		dragon = 1,		--精英头像
		raretype = 1,  	--精英头像类型：1精英头像，2银英头像，3稀有头像
		extbar = 1,  	--扩展框
		hpmp = 1,  		--不显示扩展框时增加生命值和法力值(百分比)显示
		hpmptype = 1,  	--生命值和法力值类型：1数值，2百分比
		unit = 1,  		--生命值、法力值单位，1为千进制(k/m)
		colorhp = 1,	--生命条百分比染色
		movable = 1,	--Shift拖动头像
		moving = 0,		--玩家拖动状态
		indicator = 1,	--头像内战斗信息
		p3d = 1,		--3D头像
		p3dbg = 1,		--3D头像背景
		coord = 1,		--坐标
		pettarget = 0,	--宠物目标
		ptscale = 0.8,	--宠物目标缩放比例
		pthppct = 1,	--宠物目标生命值百分比
	},

	target = {
		statustext = 1,	--在进入游戏时自动开启系统生命/法力数值显示
		autotot = 1,	--在进入游戏时自动关闭系统ToT
		classicon = 1,	--职业图标
		moreaction = 1,	--职业图标左键观察，右键交易，中键密语，4键跟随
		race = 1,		--种族和类型
		hppct = 1,		--生命值百分比
		mppct = 1,		--法力值百分比
		colorhp = 1,	--生命条百分比染色
		indicator = 1,	--头像内战斗信息
		buffsize = 1,	--调节目标buff/debuff图标大小
		mysize = 24,	--自己施放的buff/debuff大小，默认 21
		othersize = 16,	--其他人施放的buff/debuff大小，默认 17
		movable = 1,	--Shift拖动目标头像
		moving = 0,		--目标拖动状态
		moved = 0,		--目标已被拖动
		p3d = 1,		--3D头像
		p3dbg = 1,		--3D头像背景
		tot = 1,		--额外的ToT
		totot = 1,		--额外的ToToT
		scale = 0.9,	--额外的ToT缩放比例
		debuff = 1,		--额外的ToT Debuff
		tothppct = 1,	--额外的ToT 生命值百分比
		tmoving = 0,	--ToT拖动状态
		tmoved = 0,		--ToT已被拖动
	},

	focus = {
		fullsize = 1,	--在进入游戏时自动开启系统扩大焦点框架
		quick = 1,		--快速设置焦点
		button = 1,		--快速设置焦点快捷键，1alt，2shift，3ctrl
		classicon = 1,	--职业图标
		moreaction = 1,	--职业图标左键观察，右键交易，中键密语
		race = 1,		--种族和类型
		hppct = 1,		--生命值百分比
		mppct = 1,		--法力值百分比
		colorhp = 1,	--生命条百分比染色
		indicator = 1,	--头像内战斗信息
		scale = 0.9,	--额外的ToF缩放比例
		movable = 1,	--Shift拖动头像
		moving = 0,		--焦点拖动状态
		p3d = 1,		--3D头像
		p3dbg = 1,		--3D头像背景
		tof = 1,		--焦点目标
		tofhppct = 1,	--焦点目标生命值百分比
		tmoving = 0,	--焦点目标拖动状态
		tmoved = 0,		--焦点目标已被拖动
	},

	party = {
		level = 1,		--队友等级
		colorname = 1,	--队友名字染色
		hp = 1,			--队友生命值
		hppct = 1,		--队友生命值百分比
		movable = 1,	--Shift拖动头像
		moving = 0,		--队友拖动状态
		onoff = 1,		--队友离线检测
		indicator = 1,	--头像内战斗信息
		buff = 1,		--队友buff
		target = 1,		--队友目标
	},

	version = 0.9,
}

function UnitFramesPlus_Options_Init()
	if not UnitFramesPlusDB then
		UnitFramesPlusDB = UnitFramesPlusDefaultDB;
	else
		local Version = tonumber(GetAddOnMetadata("UnitFramesPlus", "Version"));
		if not UnitFramesPlusDB["version"] or UnitFramesPlusDB["version"] < Version then
			UnitFramesPlusDB = UnitFramesPlusDefaultDB;
		end
	end
end

function UnitFramesPlus_Init()
	if UnitFramesPlus_PlayerInit then
		UnitFramesPlus_PlayerInit();
	end
	if UnitFramesPlus_PetTargetInit then
		UnitFramesPlus_PetTargetInit();
	end
	if UnitFramesPlus_TargetInit then
		UnitFramesPlus_TargetInit();
	end
	if UnitFramesPlus_TargetTargetInit then
		UnitFramesPlus_TargetTargetInit();
	end
	if UnitFramesPlus_FocusInit then
		UnitFramesPlus_FocusInit();
	end
	if UnitFramesPlus_FocusTargetInit then
		UnitFramesPlus_FocusTargetInit();
	end
	if UnitFramesPlus_PartyInit then
		UnitFramesPlus_PartyInit();
	end
	if UnitFramesPlus_PartyTargetInit then
		UnitFramesPlus_PartyTargetInit()
	end
end

local ufp = CreateFrame("Frame");
ufp:RegisterEvent("ADDON_LOADED");
ufp:RegisterEvent("VARIABLES_LOADED");
ufp:RegisterEvent("PLAYER_LOGIN");
ufp:SetScript("OnEvent", function(self, event)
	if event == "ADDON_LOADED" then
		UnitFramesPlus_Options_Init();
	elseif event == "VARIABLES_LOADED" then
		print("|cFFFFFF99UnitFramesPlus loaded. Type /ufp or /unitframesplus to open the option panel.|R");
	elseif event == "PLAYER_LOGIN" then
		UnitFramesPlus_Init();
	end
end)

function UnitFramesPlus_LoadOptionPanel()
	if not IsAddOnLoaded("UnitFramesPlus_Options") then
		local _, _, _, enabled = GetAddOnInfo("UnitFramesPlus_Options");
		if not enabled then
			EnableAddOn("UnitFramesPlus_Options");
		end
		local loaded = LoadAddOn("UnitFramesPlus_Options");
		if not loaded then
			print("|cFFFF0000The option panel can't be loaded.|R");
			return false;
		end
	end
end

--Option panel
UnitFramesPlus_OptionsFrame = CreateFrame("Frame", "UnitFramesPlus_OptionsFrame", UIParent);
UnitFramesPlus_OptionsFrame:Hide();

--Add to Blizzard Interface Options
UnitFramesPlus_OptionsFrame.name = "UnitFramesPlus"
local _, title = GetAddOnInfo("UnitFramesPlus_Options");
if title ~= nil then
	InterfaceOptions_AddCategory(UnitFramesPlus_OptionsFrame);
	UnitFramesPlus_OptionsFrame:SetScript("OnShow", function()
		local result = UnitFramesPlus_LoadOptionPanel();
		if result == false then return end;
		UnitFramesPlus_OptionPanel_OnShow();
	end)
end

--Slash command
SlashCmdList["UnitFramesPlus"] = function()
	local result = UnitFramesPlus_LoadOptionPanel();
	if result == false then return end;
	InterfaceOptionsFrame_OpenToCategory("UnitFramesPlus");
end;
SLASH_UnitFramesPlus1 = "/unitframesplus";
SLASH_UnitFramesPlus2 = "/ufp";
